"""
    Dropbox Sign API

    Dropbox Sign v3 API  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: apisupport@hellosign.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from typing import TYPE_CHECKING, Optional, List, Dict, Union
import json  # noqa: F401
import re  # noqa: F401
import sys  # noqa: F401

from dropbox_sign import ApiClient
from dropbox_sign.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from dropbox_sign.exceptions import ApiAttributeError
if TYPE_CHECKING:
    from dropbox_sign.model.account_response_quotas import AccountResponseQuotas


def lazy_import():
    from dropbox_sign.model.account_response_quotas import AccountResponseQuotas
    globals()['AccountResponseQuotas'] = AccountResponseQuotas


class AccountResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'account_id': (str,),  # noqa: E501
            'email_address': (str,),  # noqa: E501
            'is_locked': (bool,),  # noqa: E501
            'is_paid_hs': (bool,),  # noqa: E501
            'is_paid_hf': (bool,),  # noqa: E501
            'quotas': (AccountResponseQuotas,),  # noqa: E501
            'callback_url': (str, none_type,),  # noqa: E501
            'role_code': (str, none_type,),  # noqa: E501
            'team_id': (str, none_type,),  # noqa: E501
            'locale': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None

    @staticmethod
    def init(data: any) -> AccountResponse:
        """
        Attempt to instantiate and hydrate a new instance of this class
        """
        try:
            obj_data = json.dumps(data)
        except TypeError:
            obj_data = data

        return ApiClient().deserialize(
            response=type('obj_dict', (object,), {'data': obj_data}),
            response_type=[AccountResponse],
            _check_type=True,
        )

    attribute_map = {
        'account_id': 'account_id',  # noqa: E501
        'email_address': 'email_address',  # noqa: E501
        'is_locked': 'is_locked',  # noqa: E501
        'is_paid_hs': 'is_paid_hs',  # noqa: E501
        'is_paid_hf': 'is_paid_hf',  # noqa: E501
        'quotas': 'quotas',  # noqa: E501
        'callback_url': 'callback_url',  # noqa: E501
        'role_code': 'role_code',  # noqa: E501
        'team_id': 'team_id',  # noqa: E501
        'locale': 'locale',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @property
    def account_id(self) -> str:
        return self.get("account_id")

    @account_id.setter
    def account_id(self, value: str):
        setattr(self, "account_id", value)

    @property
    def email_address(self) -> str:
        return self.get("email_address")

    @email_address.setter
    def email_address(self, value: str):
        setattr(self, "email_address", value)

    @property
    def is_locked(self) -> bool:
        return self.get("is_locked")

    @is_locked.setter
    def is_locked(self, value: bool):
        setattr(self, "is_locked", value)

    @property
    def is_paid_hs(self) -> bool:
        return self.get("is_paid_hs")

    @is_paid_hs.setter
    def is_paid_hs(self, value: bool):
        setattr(self, "is_paid_hs", value)

    @property
    def is_paid_hf(self) -> bool:
        return self.get("is_paid_hf")

    @is_paid_hf.setter
    def is_paid_hf(self, value: bool):
        setattr(self, "is_paid_hf", value)

    @property
    def quotas(self) -> AccountResponseQuotas:
        return self.get("quotas")

    @quotas.setter
    def quotas(self, value: AccountResponseQuotas):
        setattr(self, "quotas", value)

    @property
    def callback_url(self) -> Optional[str]:
        return self.get("callback_url")

    @callback_url.setter
    def callback_url(self, value: Optional[str]):
        setattr(self, "callback_url", value)

    @property
    def role_code(self) -> Optional[str]:
        return self.get("role_code")

    @role_code.setter
    def role_code(self, value: Optional[str]):
        setattr(self, "role_code", value)

    @property
    def team_id(self) -> Optional[str]:
        return self.get("team_id")

    @team_id.setter
    def team_id(self, value: Optional[str]):
        setattr(self, "team_id", value)

    @property
    def locale(self) -> Optional[str]:
        return self.get("locale")

    @locale.setter
    def locale(self, value: Optional[str]):
        setattr(self, "locale", value)

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """AccountResponse - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_id (str): The ID of the Account. [optional]  # noqa: E501
            email_address (str): The email address associated with the Account.. [optional]  # noqa: E501
            is_locked (bool): Returns `true` if the user has been locked out of their account by a team admin.. [optional]  # noqa: E501
            is_paid_hs (bool): Returns `true` if the user has a paid Dropbox Sign account.. [optional]  # noqa: E501
            is_paid_hf (bool): Returns `true` if the user has a paid HelloFax account.. [optional]  # noqa: E501
            quotas (AccountResponseQuotas): [optional]  # noqa: E501
            callback_url (str, none_type): The URL that Dropbox Sign events will `POST` to.. [optional]  # noqa: E501
            role_code (str, none_type): The membership role for the team.. [optional]  # noqa: E501
            team_id (str, none_type): The id of the team account belongs to.. [optional]  # noqa: E501
            locale (str, none_type): The locale used in this Account. Check out the list of [supported locales](/api/reference/constants/#supported-locales) to learn more about the possible values.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """AccountResponse - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            account_id (str): The ID of the Account. [optional]  # noqa: E501
            email_address (str): The email address associated with the Account.. [optional]  # noqa: E501
            is_locked (bool): Returns `true` if the user has been locked out of their account by a team admin.. [optional]  # noqa: E501
            is_paid_hs (bool): Returns `true` if the user has a paid Dropbox Sign account.. [optional]  # noqa: E501
            is_paid_hf (bool): Returns `true` if the user has a paid HelloFax account.. [optional]  # noqa: E501
            quotas (AccountResponseQuotas): [optional]  # noqa: E501
            callback_url (str, none_type): The URL that Dropbox Sign events will `POST` to.. [optional]  # noqa: E501
            role_code (str, none_type): The membership role for the team.. [optional]  # noqa: E501
            team_id (str, none_type): The id of the team account belongs to.. [optional]  # noqa: E501
            locale (str, none_type): The locale used in this Account. Check out the list of [supported locales](/api/reference/constants/#supported-locales) to learn more about the possible values.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
